#! /usr/bin/env perl
#
# tag: ewok install prerequisite checks
#

use strict;

my $bad = 0;

sub check 
{
    my ($module, $version) = @_;
    if (! defined eval "require $module") {
        print "You are missing $module - please install\n";
        $bad = 1;
    }
    elsif ($version) {
        my $v = eval "require $module; \$${module}::VERSION";
        if (! $v) {
            print "Unable to determine version for $module\n";
            $bad = 1;
        }
        elsif ($version gt $v) {
            print "Your version of $module is $v - please upgrade to (at least) $version\n";
            $bad = 1;
        }
    }
}

# check('HTML::Foo', '1.3.5');
check('HTML::Embperl', '1.3.4');
check('URI::Escape');
check('File::DirSync');
check('Data::Dumper');
check('Fcntl');
check('POSIX');
check('Carp');
check('Safe');

exit $bad;
