# tag: ewok breadcrumbs class

package Ewok::Breadcrumbs;
use OF::Breadcrumbs;

@ISA = qw(OF::Breadcrumbs);

use Ewok::Meta qw(getMeta);
use strict;

#
# Try and derive unspecified labels from metadata
#
sub label_default
{
    my $self = shift;
    my ($elt, $req) = @_;
    my $label = '';

    if (ref $req) {
        # Use the apache request object to get the filesystem-relative elt name
        my $fs_elt = $req->{req_rec}->lookup_uri($elt)->filename();
        $fs_elt .= '/' if substr($fs_elt,-1) ne '/' && -d $fs_elt;
        # Load metadata
        my $meta = getMeta($fs_elt);
        # Use metadata short_title, or h1, or metadata title for label
        $label = $meta->{short_title} if ref $meta;
        $label ||= $req->{h1} if $fs_elt eq $req->{fs_file};
        $label ||= $meta->{title} if ref $meta;
    }

    # Fallback to default behaviour
    $label ||= $self->SUPER::label_default(@_);

    return $label;
}

1;

